/* random.c */
/**/

#include "imoria.h"
#include <sys/time.h>

//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
unsigned long get_seed()
{
//	{ Use date and time to produce a random seed	-RAK-	}
  struct timeval tv;
  unsigned long the_seed;

  ENTER("get_seed","");

  gettimeofday(&tv, NULL);

  the_seed  = tv.tv_usec ^ tv.tv_sec;

  //  the_seed = 883993667;

  RETURN("get_seed","",'u',"rand seed",&the_seed);
  return the_seed;
}; /* end get_seed */
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
void set_seed(unsigned long the_seed)
{
  /* use the_seed to seed the generator */

#if DO_DEBUG
  fprintf(debug_file,"set_seed: s= %ld\n",the_seed);
  fflush(debug_file);
#endif	  

#if USE_MTWIST
  seedMT(the_seed);
#else
  srand(the_seed);
#endif
}; /* end get_seed */
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
integer randnor(integer mean,integer stand)
{
/*{ Generates a random integer number of NORMAL distribution -RAK-}*/

  return (integer)(sqrt(-2.0*log(randint(9999999)/10000000.0))*
		   cos(6.283*(randint(9999999)/10000000.0))*stand) + mean;
};
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
integer rand_rep(integer num, integer die)
{
  integer i1, sum=0;

  for (i1 = 0; i1 < num; i1++) {
    sum += randint(die);
  }

  return sum;
};
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
integer randint(integer maxval)
{
/* Generates a random integer x where 1<=X<=MAXVAL	-RAK-	*/

  integer r = 0;
  
  if (maxval) {
#if USE_MTWIST
    r = ((randomMT() % maxval) + 1);
#else
    r = ((rand() % maxval) + 1);
#endif
  }

  /*
#if DO_DEBUG
   fprintf(debug_file, "   rand:  %ld\t(%ld)\n", r, maxval);
   fflush(debug_file);
#endif	  
*/

  return r;
};
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
void *save_rand_state(void *randState)
{
#if USE_MTWIST
  return saveMTstate(randState);
#else
  return NULL;
#endif
};
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
void restore_rand_state(void *randState)
{
#if USE_MTWIST
  if (randState != NULL) {
    restoreMTstate(randState);
    free(randState);
  }
#endif
};
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////

/* END FILE random.c */
